#ifndef CLOUDFACTORY_H
#define CLOUDFACTORY_H

#include "Cloud.h"

// Work around compilers that don't support C++11.
#define override

namespace cloud {

class CloudFactory {
public:
  virtual FileSystem *CreateFileSystem() = 0;
  virtual File *CreateFile() = 0;
  virtual Folder *CreateFolder() = 0;

  virtual ~CloudFactory() = 0;
};

class DBoxFactory: public CloudFactory {
public:
  FileSystem *CreateFileSystem() override;
  File *CreateFile() override;
  Folder *CreateFolder() override;

  ~DBoxFactory() override;
};

class GDriveFactory: public CloudFactory {
public:
  FileSystem *CreateFileSystem() override;
  File *CreateFile() override;
  Folder *CreateFolder() override;

  ~GDriveFactory() override;
};

} // namespace cloud
#endif
