#ifndef DBOXCLIENT_H
#define DBOXCLIENT_H

#include "Cloud.h"

using cloud::FileSystem;
using cloud::File;
using cloud::Folder;

// Work around compilers that don't support C++11.
#define override

namespace cloud {
namespace dbox {

class DBoxFileSystem: public FileSystem
{
public:
  virtual void Connect(const char *aHost, uint16_t aPort) override;
  virtual bool IsConnected() override;
  virtual void Disconnect() override;

  virtual ~DBoxFileSystem() override;
};

class DBoxFile: public File {
public:
  virtual const char * GetName() const override;
  virtual void Delete() override;

  virtual ~DBoxFile() override;

};

class DBoxFolder: public Folder
{
public:
  virtual void Delete() override;

  virtual ~DBoxFolder() override;
};

}
}

#endif
