#include "Cloud.h" // Note that we don't include GDriveClient.h directly.
#include "CloudFactory.h"
#include <iostream>

using namespace cloud;

void CloudDriveClient()
{
  // Note that the following line is the only one line where the "GDrive"
  // appears in the class name.
  CloudFactory *factory = new DBoxFactory();  // To use the DBox client.
  FileSystem *fileSystem = factory->CreateFileSystem();
  fileSystem->Connect("server.dbox.com", 11001);
  if (!fileSystem->IsConnected()) {
    return;
  }

  // Note how the derived class names disappear in this file: derived classes
  // are no longer new'd here.
  File *file1 = factory->CreateFile();
  // ... (use the file)
  std::cout << "Use remote file " << file1->GetName() << "\n";

  Folder *folder1 = factory->CreateFolder();
  // ... (use the folder)

  delete folder1;
  delete file1;

  fileSystem->Disconnect();
  delete fileSystem;
}
