#include "DBoxClient.h"

namespace cloud {
namespace dbox {

void
DBoxFileSystem::Connect(const char* aHost, uint16_t aPort)
{
  // Forward the invocation to vendor implementation.
  ConnectTo(aHost, aPort);
}

bool
DBoxFileSystem::IsConnected()
{
  // Forward the invocation to vendor implementation.
  return IsOnline();
}

void
DBoxFileSystem::Disconnect()
{
  // Forward the invocation to vendor implementation.
  Detach();
}

DBoxFileSystem::~DBoxFileSystem()
{
}

const char*
DBoxFile::GetName() const
{
  // Use qualified name to disambiguate that we are calling the inherited
  // implementation from cloud::dbox::impl::DBoxFileImpl, not making a recursive
  // call to self.
  return impl::DBoxFileImpl::GetName();
}

void
DBoxFile::Delete()
{
  // The option of purging history is lost in the adaptation.
  Remove(true);
}

DBoxFile::~DBoxFile()
{
}

void DBoxFolder::Delete()
{
  // The option of temporary removal is lost in the adaptation.
  Remove(true);
}

DBoxFolder::~DBoxFolder()
{
}

} // namespace impl
} // namespace cloud

